function [residual, g1, g2, g3] = second_paper_dyn_dynamic(y, x, params, it_)
%
% Status : Computes dynamic model for Dynare
%
% Warning : this file is generated automatically by Dynare
%           from model file (.mod)

%
% Model equations
%

residual = zeros(9, 1);
lhs =0;
rhs =(-y(5))+y(13)-params(20)*y(7)+params(21)*(y(10)-y(14));
residual(1)= lhs-rhs;
lhs =0;
rhs =y(10)+(-y(12))-params(4)*params(2)/(1+params(2)*(1-params(4)))*(params(15)-params(22))*y(9);
residual(2)= lhs-rhs;
lhs =0;
rhs =y(10)+(-y(11))+y(9)*params(4)*params(2)/(1+params(2)*(1-params(4)))*(1+params(22));
residual(3)= lhs-rhs;
lhs =0;
rhs =y(10)*(-(1-params(4)+params(1)))/params(4)-y(5)-params(22)*y(9);
residual(4)= lhs-rhs;
lhs =0;
rhs =y(12)*(-params(16))+y(5)*params(3)*params(17)+y(9)*params(17)*(1-params(3))*params(5)+params(8)*y(4)+y(9)*(params(8)+params(15)*params(9))-params(11)*(y(6)-y(2));
residual(5)= lhs-rhs;
lhs =0;
rhs =y(11)*(-(1-params(16)))+y(5)*params(17)*(1-params(3))-y(9)*params(17)*(1-params(3))*params(5)-params(8)*y(4)+params(10)*(y(8)-y(3));
residual(6)= lhs-rhs;
lhs =0;
rhs =(-y(6))+y(2)*params(13)+y(4)*params(8)*(1-params(6))/params(11);
residual(7)= lhs-rhs;
lhs =0;
rhs =(-y(8))+y(3)*params(14)+y(4)*params(8)*(1-params(7))/params(10);
residual(8)= lhs-rhs;
lhs =0;
rhs =(-y(4))+params(12)*y(1)+x(it_, 1);
residual(9)= lhs-rhs;
if nargout >= 2,
  g1 = zeros(9, 15);

%
% Jacobian matrix
%

  g1(1, 5)=  g1(1, 5)+1;
  g1(1, 13)=  g1(1, 13)+(-1);
  g1(1, 7)=  g1(1, 7)+params(20);
  g1(1, 10)=  g1(1, 10)+(-params(21));
  g1(1, 14)=  g1(1, 14)+params(21);
  g1(2, 10)=  g1(2, 10)+(-1);
  g1(2, 12)=  g1(2, 12)+1;
  g1(2, 9)=  g1(2, 9)+params(4)*params(2)/(1+params(2)*(1-params(4)))*(params(15)-params(22));
  g1(3, 10)=  g1(3, 10)+(-1);
  g1(3, 9)=  g1(3, 9)+(-(params(4)*params(2)/(1+params(2)*(1-params(4)))*(1+params(22))));
  g1(3, 11)=  g1(3, 11)+1;
  g1(4, 5)=  g1(4, 5)+1;
  g1(4, 10)=  g1(4, 10)+(-((-(1-params(4)+params(1)))/params(4)));
  g1(4, 9)=  g1(4, 9)+params(22);
  g1(5, 5)=  g1(5, 5)+(-(params(3)*params(17)));
  g1(5, 12)=  g1(5, 12)+params(16);
  g1(5, 9)=  g1(5, 9)+(-(params(17)*(1-params(3))*params(5)+params(8)+params(15)*params(9)));
  g1(5, 4)=  g1(5, 4)+(-params(8));
  g1(5, 6)=  g1(5, 6)+params(11);
  g1(5, 2)=  g1(5, 2)+(-params(11));
  g1(6, 5)=  g1(6, 5)+(-(params(17)*(1-params(3))));
  g1(6, 9)=  g1(6, 9)+params(17)*(1-params(3))*params(5);
  g1(6, 11)=  g1(6, 11)+1-params(16);
  g1(6, 4)=  g1(6, 4)+params(8);
  g1(6, 8)=  g1(6, 8)+(-params(10));
  g1(6, 3)=  g1(6, 3)+params(10);
  g1(7, 4)=  g1(7, 4)+(-(params(8)*(1-params(6))/params(11)));
  g1(7, 6)=  g1(7, 6)+1;
  g1(7, 2)=  g1(7, 2)+(-params(13));
  g1(8, 4)=  g1(8, 4)+(-(params(8)*(1-params(7))/params(10)));
  g1(8, 8)=  g1(8, 8)+1;
  g1(8, 3)=  g1(8, 3)+(-params(14));
  g1(9, 4)=  g1(9, 4)+1;
  g1(9, 1)=  g1(9, 1)+(-params(12));
  g1(9, 15)=  g1(9, 15)+(-1);
end
if nargout >= 3,
  g2 = sparse([],[],[], 9, 225, 1125);

%
% Hessian matrix
%

end;
