function [residual, g1, g2] = second_paper_dyn_static(y, x, params)
%
% Status : Computes static model for Dynare
%
% Warning : this file is generated automatically by Dynare
%           from model file (.mod)

residual = zeros( 9, 1);

%
% Model equations
%

lhs =0;
rhs =(-y(2))+y(2)-params(20)*y(4)+params(21)*(y(7)-y(7));
residual(1)= lhs-rhs;
lhs =0;
rhs =y(7)+(-y(9))-params(4)*params(2)/(1+params(2)*(1-params(4)))*(params(15)-params(22))*y(6);
residual(2)= lhs-rhs;
lhs =0;
rhs =y(7)+(-y(8))+y(6)*params(4)*params(2)/(1+params(2)*(1-params(4)))*(1+params(22));
residual(3)= lhs-rhs;
lhs =0;
rhs =y(7)*(-(1-params(4)+params(1)))/params(4)-y(2)-params(22)*y(6);
residual(4)= lhs-rhs;
lhs =0;
rhs =y(9)*(-params(16))+y(2)*params(3)*params(17)+y(6)*params(17)*(1-params(3))*params(5)+params(8)*y(1)+y(6)*(params(8)+params(15)*params(9))-params(11)*(y(3)-y(3));
residual(5)= lhs-rhs;
lhs =0;
rhs =y(8)*(-(1-params(16)))+y(2)*params(17)*(1-params(3))-y(6)*params(17)*(1-params(3))*params(5)-params(8)*y(1)+params(10)*(y(5)-y(5));
residual(6)= lhs-rhs;
lhs =0;
rhs =(-y(3))+y(3)*params(13)+y(1)*params(8)*(1-params(6))/params(11);
residual(7)= lhs-rhs;
lhs =0;
rhs =(-y(5))+y(5)*params(14)+y(1)*params(8)*(1-params(7))/params(10);
residual(8)= lhs-rhs;
lhs =0;
rhs =(-y(1))+params(12)*y(1)+x(1);
residual(9)= lhs-rhs;
if ~isreal(residual)
  residual = real(residual)+imag(residual).^2;
end
if nargout >= 2,
  g1 = zeros(9, 9);

%
% Jacobian matrix
%

  g1(1, 2)=  g1(1, 2)+1;
  g1(1, 2)=  g1(1, 2)+(-1);
  g1(1, 4)=  g1(1, 4)+params(20);
  g1(1, 7)=  g1(1, 7)+(-params(21));
  g1(1, 7)=  g1(1, 7)+params(21);
  g1(2, 7)=  g1(2, 7)+(-1);
  g1(2, 9)=  g1(2, 9)+1;
  g1(2, 6)=  g1(2, 6)+params(4)*params(2)/(1+params(2)*(1-params(4)))*(params(15)-params(22));
  g1(3, 7)=  g1(3, 7)+(-1);
  g1(3, 6)=  g1(3, 6)+(-(params(4)*params(2)/(1+params(2)*(1-params(4)))*(1+params(22))));
  g1(3, 8)=  g1(3, 8)+1;
  g1(4, 2)=  g1(4, 2)+1;
  g1(4, 7)=  g1(4, 7)+(-((-(1-params(4)+params(1)))/params(4)));
  g1(4, 6)=  g1(4, 6)+params(22);
  g1(5, 2)=  g1(5, 2)+(-(params(3)*params(17)));
  g1(5, 9)=  g1(5, 9)+params(16);
  g1(5, 6)=  g1(5, 6)+(-(params(17)*(1-params(3))*params(5)+params(8)+params(15)*params(9)));
  g1(5, 1)=  g1(5, 1)+(-params(8));
  g1(5, 3)=  g1(5, 3)+params(11);
  g1(5, 3)=  g1(5, 3)+(-params(11));
  g1(6, 2)=  g1(6, 2)+(-(params(17)*(1-params(3))));
  g1(6, 6)=  g1(6, 6)+params(17)*(1-params(3))*params(5);
  g1(6, 8)=  g1(6, 8)+1-params(16);
  g1(6, 1)=  g1(6, 1)+params(8);
  g1(6, 5)=  g1(6, 5)+(-params(10));
  g1(6, 5)=  g1(6, 5)+params(10);
  g1(7, 1)=  g1(7, 1)+(-(params(8)*(1-params(6))/params(11)));
  g1(7, 3)=  g1(7, 3)+1;
  g1(7, 3)=  g1(7, 3)+(-params(13));
  g1(8, 1)=  g1(8, 1)+(-(params(8)*(1-params(7))/params(10)));
  g1(8, 5)=  g1(8, 5)+1;
  g1(8, 5)=  g1(8, 5)+(-params(14));
  g1(9, 1)=  g1(9, 1)+1;
  g1(9, 1)=  g1(9, 1)+(-params(12));
  if ~isreal(g1)
    g1 = real(g1)+2*imag(g1);
  end
end
